
use EPrints::Const qw( :trigger :http );

# Make a permentant link to the latest document in an eprint. eg /23/latest/foo.txt go
$c->add_trigger( EP_TRIGGER_URL_REWRITE, sub {
	my( %args ) = @_;

	my( $uri, $urlpath, $repository ) = @args{qw/ uri urlpath repository /};

	my( $eprintid, $path ) = ( $1, $2 );
	if( $uri =~ m!^$urlpath/([1-9][0-9]*)/latest/(.*)! )
	{
		( $eprintid, $path ) = ( $1, $2 );
	}
	else
	{
		return;
	}
	
	my $eprint = $repository->eprint( $eprintid );
	return if( !defined $eprint );

	my @docs = sort { ($a->get_value( "pos" )||0) <=> ($b->get_value( "pos" )||0) || $a->id <=> $b->id } 
			$eprint->get_all_documents();
	if( !scalar @docs ) { return; }

	my $doc = pop @docs;

	my $newuri = "$urlpath/$eprintid/".$doc->value( "pos" )."/$path";

	$args{request}->uri( $newuri );
	${$args{return_code}} = EPrints::Apache::Rewrite::handler( $args{request} );

	return EP_TRIGGER_DONE;
}, priority => 200 );
